import * as React from 'react';
import { Colors, Squares, CastlingStr, IChessOpening } from 'onix-chess';
import * as cg from 'chessground/types';
import { BoardSize } from 'onix-board-assets';
declare type Selected = "pointer" | "trash" | [cg.Color, cg.Role];
export interface PosBuilderProps {
    locale?: string;
    url?: string;
    dialog?: boolean;
    fen?: string;
    orientation?: cg.Color;
    showTurn?: boolean;
    coordinates?: boolean;
    size: BoardSize;
    piece?: string;
    square?: string;
    markers?: string;
    openings?: IChessOpening[];
}
export interface PosBuilderState {
    piece?: string;
    square?: string;
    size: BoardSize;
    coordinates?: boolean;
    orientation?: cg.Color;
    showTurn?: boolean;
    fen?: string;
    whoMove?: Colors.BW;
    castling?: CastlingStr;
    ep_target?: Squares.Square;
    halfMove?: number;
    moveNo?: number;
    markers?: string;
    markersVal: string;
    openings?: IChessOpening[];
    selected: Selected;
}
export declare class PosBuilder extends React.Component<PosBuilderProps, PosBuilderState> {
    static defaultProps: PosBuilderProps;
    private boardElement;
    private markElement;
    private cg?;
    private sizeChanged;
    constructor(props: PosBuilderProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    private redrawBoard;
    private flipBoard;
    private updateConfig;
    private markersToShapes;
    private shapesToMarkers;
    private assignShapes;
    private onDrawShape;
    private onSizeChange;
    private onPieceChange;
    private onSquareChange;
    private onFlipChange;
    private onCoordsChange;
    private onTurnChange;
    private onPositionChange;
    private onStartChange;
    private onMoverChange;
    private onCastleChange;
    private onMoveNoChange;
    private onEpChange?;
    private onMarkChange;
    private renderCastlingGroup;
    private fullFen;
    private makeLink;
    private makeCode;
    private renderDialogButton;
    private select;
    private onSelectSparePiece;
    private renderSpare;
    private downKey;
    private lastKey;
    private placeDelete;
    private deleteOrHidePiece;
    private deletePiece;
    private boardEvent;
    render(): JSX.Element;
}
export declare const PositionSetup: (props: PosBuilderProps, container: HTMLElement) => void;
export {};
